# Development Process

After [Setting up the workspace](https://app.gitbook.com/s/-MEOm98BbzqckTUoLpXN/general/frontend/documentation/winforms-angular-components/home.md) and [Front-End setup and compilation](https://app.gitbook.com/s/-MEOm98BbzqckTUoLpXN/general/frontend/documentation/winforms-angular-components/setup/setupCompilationFrontEnd.md) we should be able to add, modify or delete code.

## Documentation

It is important to document and comment our code for the future understanding.

Formal documentation is made by DocFx which is a API documentation generator that builds a static HTML website from our Markdown files

There is a docs folder that contains a documentation structure , after adding a new Mark Down file we have to make sure that is referenced on `toc.yml` file.

Like this:

```
- name: Architecture
  href: architecture.md
- name: Migrated Structure
  href: structure/migratedStructure.md
- name: Setup
  items:
    - name: Browser Support
      href: setup/browser-support.md
- name: Base Components
  items:
    - name: Control Component
      href: winforms/base-components/control-mapper.md
- name: JQuery Web Components
  href: jquery-web-components.md 
- name: KendoUI Components
  items:
    - name: AdoDataControl
      href: winforms/kendoui/adodatacontrolcomponent.md
    - name: Button 
      href: winforms/kendoui/buttoncomponent.md
- name: Decorators
  items:
    - name: Server Event
      href:  winforms/decorators/server-event-decorator.md
- name: Conventions
  items:
    - name: Application Structure and NgModules
      href: Conventions/Application-structure-and-NgModules-Conventions.md
    - name: Coding
      href: Conventions/Coding-conventions.md
```

Also is important to add comments to the code and make sure that is aligned.

```typescript
    /**
     * This is a comment for new newFunction
     */
    newFunction(): void {
    console.log("This is a new function");
    }
```

## Testing

We manage high percentage of coverage on our code, it is important to make sure that everything have been tested, here is a guide about how it works [Unit Test Manual](/webmap/general/frontend/documentation/winforms-angular-components/setup/unit-test-manual.md)

## Pull Request

When our code is ready is time to make a pull request, this needs to be be approved by two developers in order to be merged on our develop branch.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.gapvelocity.ai/webmap/general/frontend/documentation/winforms-angular-components/setup/development-process.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
